# Search API Japanese Normalizer

Search API Japanese Normalizerは、Drupalの[Search API]モジュール向けのプロセッサーを提供するモジュールです。このプロセッサーを使用すると、日本語文章の表記揺れを統一し、検索の精度を向上させることができます。

## 機能

日本語の表記揺れを次のルールに基づいて統一します。

- 全角英数字を半角に置換
- 半角カタカナを全角に置換
- ハイフンマイナスに類似する文字を統一
- 長音記号に類似する文字を統一
- 連続する長音記号を1つに置換
- チルダに類似する文字を削除
- 全角記号のうち、半角が一般的なものを半角記号に統一
- 半角記号のうち、全角が一般的なものを全角記号に統一
- 全角スペースを半角スペースに置換
- 1つ以上の半角スペースは、1つの半角スペースに置換
- 「ひらがな・全角カタカナ・半角カタカナ・漢字・全角記号」間に含まれる半角スペースを削除
- 「ひらがな・全角カタカナ・半角カタカナ・漢字・全角記号」と「半角英数字」の間に含まれる半角スペースを削除

本モジュールの実装にあたり、[NEologd](https://github.com/neologd/mecab-ipadic-neologd)という形態素解析器用の辞書に使われる正規化ルールを参考にさせていただきました。詳しい変換ルールは[NEologdの正規化ルール](https://github.com/neologd/mecab-ipadic-neologd/wiki/Regexp.ja)のページを参照してください。

変換の一例:

| 変換前         | 変換後     |
| -------------- | ---------- |
| ﾄﾞﾙｰﾊﾟﾙ        | ドルーパル |
| スーーパーーー | スーパー   |
| アルゴリズム　Ｃ | アルゴリズムC |

## インストール後

Search APIのインデックス設定画面の「プロセッサー」タブに「Japanese Normalizer」が追加されます。このプロセッサーを有効化すると、日本語の表記揺れが自動的に修正され、検索精度が向上します。

## 追加要件

本モジュールを使用するには、[Search API]モジュールが必要です。設定方法については、[Search API モジュールのドキュメント](https://www.drupal.org/docs/contributed-modules/search-api)を参照してください。

## 類似プロジェクト

- [Search API Kana Convert](https://www.drupal.org/project/search_api_kana_convert) ひらがな・カタカナ・アルファベットの変換に特化したモジュールです。

## メンテナー

- [大野 裕太郎 (u7aro)](https://www.drupal.org/u/u7aro)
- [寺尾 泰輝 (terao3)](https://www.drupal.org/u/terao3)

このプロジェクトは次の団体の支援を受けています:

- [スタジオ・ウミ株式会社](https://www.studio-umi.jp/)

[Search API]: https://www.drupal.org/project/search_api
