<?php

namespace Drupal\search_api_japanese_normalizer\Plugin\search_api\processor;

use Drupal\search_api_japanese_normalizer\Utility\NeologdNormalizer;
use Drupal\search_api\Processor\FieldsProcessorPluginBase;

/**
 * Provides processing to normalize Japanese text.
 *
 * @SearchApiProcessor(
 *   id = "search_api_japanese_normalizer",
 *   label = @Translation("Japanese Normalizer"),
 *   description = @Translation("Provides processing to normalize Japanese text."),
 *   stages = {
 *     "preprocess_index" = -9,
 *     "preprocess_query" = -9,
 *   }
 * )
 */
class SearchApiJapaneseNormalizer extends FieldsProcessorPluginBase {

  /**
   * {@inheritdoc}
   */
  protected function process(&$value) {
    $value = NeologdNormalizer::normalize($value);
  }

}
